import { TableStructure } from '@cubejs-backend/base-driver';
import { DriverFactory } from './DriverFactory';
import { QueryWithParams } from './QueryCache';
import { PreAggregationDescription, TableCacheEntry, VersionEntriesObj } from './PreAggregations';
type PreAggregationLoadCacheOptions = {
    requestId?: string;
    dataSource: string;
    tablePrefixes?: string[];
};
export declare class PreAggregationLoadCache {
    private readonly driverFactory;
    private readonly queryCache;
    private readonly preAggregations;
    private readonly queryResults;
    private readonly externalDriverFactory;
    private readonly requestId;
    private versionEntries;
    private tables;
    private tableColumnTypes;
    private queryStageState;
    private readonly dataSource;
    private readonly tablePrefixes;
    constructor(clientFactory: DriverFactory, queryCache: any, preAggregations: any, options?: PreAggregationLoadCacheOptions);
    protected tablesFromCache(preAggregation: any, forceRenew?: boolean): Promise<any>;
    fetchTables(preAggregation: PreAggregationDescription): Promise<any>;
    private fetchTablesNoCache;
    tablesCachePrefixKey(preAggregation: PreAggregationDescription): string;
    protected getTablesQuery(preAggregation: any): Promise<TableCacheEntry[]>;
    getTableColumnTypes(preAggregation: PreAggregationDescription, tableName: string): Promise<TableStructure>;
    private calculateVersionEntries;
    getVersionEntries(preAggregation: any): Promise<VersionEntriesObj>;
    keyQueryResult(sqlQuery: QueryWithParams, waitForRenew: boolean, priority: number): Promise<any>;
    hasKeyQueryResult(keyQuery: any): boolean;
    getQueryStage(stageQueryKey: any): Promise<{
        stage: string;
        timeElapsed: number;
    }>;
    protected fetchQueryStageState(queue?: any): Promise<any>;
    reset(preAggregation: any): Promise<void>;
}
export {};
//# sourceMappingURL=PreAggregationLoadCache.d.ts.map